/*
 * jQuery Mighty Form Styler plugin
 * Replaces your form select element for a html dropdown list which you can easily style with css.
 * Examples and documentation at: http://www.binkje.nl/mfs
 * 
 * Copyright (c) 2013 Bas van den Wijngaard
 * Version: 1.0.3
 * Licensed under the MIT License:
 * http://www.binkje.nl/mfs/license
 *
 * Requires jQuery 1.7 or later
 * 
 * Usage: $('#myForm').mfs(options);    - Enables the magic for your form, see available options below
 *        $('#myForm').mfs('refresh');  - Refreshes the styled selects (e.g. when you updated the select via ajax)
 *        $('#myForm').mfs('destroy');  - Removes the magic from your form
 *
 * options = {
 *      'dropdownHandle': '<i class="icon-chevron-down"></i>', // - Alternative HTML to use in the handle (i.e. fontawesome icons)
 *      'enableScroll'  : false,    // Set to true to enable scrolling in dropdown list
 *      'maxHeight'     : 200,      // Set the max height for the dropdown list in pixels (enableScroll needs to be set to true)
 *      'autoWidth'     : false,    // Set to true to adjust dropdown list width to widest option
 *      'disableTouch'  : false     // Set to true to use native select dropdown on mobile and touch devices
 *           }
 *
 */(function(e){var t=!1,n=!1,r=!1,i="",s="&nbsp;",o=/Android|webOS|iPad|iPhone/i.test(navigator.userAgent),u=function(r){var u=r.find("select"),a=u.find("option"),f=r.find("a.mfs-selected-option"),c=r.find("ul.mfs-options"),p=c.find("li.mfs-option"),d=c.find("a");c.hide();t=!1;i="";if(n.disableTouch===!0&&o===!0){f.click(function(){u.focus();return!1});u.change(function(){l(r)})}else f.click(function(){var r=e("ul.mfs-options");if(c.is(":visible")){c.hide();t=!1;i=""}else{p.removeClass("active");r.hide();c.show();var s=c.find("li.mfs-option.selected");s.length>0?s.addClass("active"):c.find("li.mfs-option:first-child").addClass("active");n.enableScroll===!0&&h(c);t=c}e(this).blur();return!1});d.click(function(){p.removeClass("active").removeClass("selected");e(this).closest("li").addClass("selected");s="&nbsp;";n.dropdownHandle!==!1&&(s=n.dropdownHandle);f.html(e(this).text()+"<span>"+s+"</span>");a.removeAttr("selected");a.eq(e(this).attr("index")).prop("selected","selected");c.hide();t=!1;i="";if(u.selectedIndex!==e(this).attr("index")&&u.onchange){u.selectedIndex=e(this).attr("index");u.onchange()}if(u.selectedIndex!==e(this).attr("index")){u.selectedIndex=e(this).attr("index");u.trigger("change")}return!1});p.mouseover(function(){p.removeClass("active");e(this).addClass("active")});u.addClass("mfs-enabled")},a=function(t){var r="notouch";n.disableTouch===!0&&o===!0&&(r="");t.after('<div class="mfs-container '+r+'"></div>');var i=t.next("div.mfs-container");t.appendTo(i);var a="",f="",l="",c=0,h="",p="";n.autoWidth===!0&&(p='style="white-space: nowrap;"');t.find("> option, optgroup").each(function(){var t=e(this).get(0).tagName.toLowerCase();if(t==="option"){var n="",r=e(this).html();if(a===""||e(this).is(":selected")){a=r;e(this).is(":selected")&&(n=" selected")}l+='<li class="mfs-option'+n+'"><a href="#" index="'+c+'"'+p+">"+r+"</a></li>";c++}if(t==="optgroup"){var i=e(this).attr("label"),s='<li class="mfs-optgroup">'+i+"</li>";e(this).find("option").each(function(){var t="",n=e(this).html();if(a===""||e(this).is(":selected")){a=n;e(this).is(":selected")&&(t=" selected")}s+='<li class="mfs-option mfs-optgroup-option'+t+'"><a href="#" index="'+c+'"'+p+">"+n+"</a></li>";c++});l+=s}});n.dropdownHandle!==!1&&(s=n.dropdownHandle);n.enableScroll===!0&&(h="overflow-y:auto;max-height:"+n.maxHeight+"px;");n.autoWidth===!0&&(h="width:auto;min-width:100%;");h.length>0&&(h='style="'+h+'"');f+='<a class="mfs-selected-option" href="#">'+a+"<span>"+s+"</span></a>";f+='<ul class="mfs-options"'+h+">"+l+"</ul>";i.prepend(f);u(i)},f=function(e){var t=e.find("select");t.removeClass("mfs-enabled");e.before(t);e.remove()},l=function(e){var t=e.find("select");e.before(t);e.remove();a(t)},c=function(e){r!==!1&&clearTimeout(r);r=setTimeout(function(){i=""},1e3);var n=String.fromCharCode(e);i+=String(n);var s=t.find("a:mfssearch('"+i+"')").filter(":first");if(s.length>0){t.find("li.active").removeClass("active");s.closest("li").addClass("active");h(t)}},h=function(e){if(n.enableScroll===!0){var t=e.find("li.mfs-option.active"),r=t.height(),i=t.position(),s=t.offset(),o=e.height();i.top>n.maxHeight-24?e.scrollTop(e.scrollTop()+s.top-e.offset().top-(o-r)+5):i.top<5&&e.scrollTop(e.scrollTop()+s.top-e.offset().top-5)}},p={init:function(r){n=e.extend({refresh:!0,radio:!1,checkbox:!1,dropdownHandle:!1,enableScroll:!1,maxHeight:200,autoWidth:!1,disableTouch:!1},r);this.each(function(){var t=e(this),n=t.find("select");n.length>0&&n.each(function(){var t=e(this);t.hasClass("mfs-enabled")||a(t)})});e(window).click(function(){e("ul.mfs-options").hide();t=!1;i=""});e(document).off("keydown.mfs");e(document).on("keydown.mfs",function(n){var r=n.keyCode;if(t===!1||r!==13&&r!==38&&r!==40&&r!==27){if(t!==!1&&r!==37&&r!==39&&r!==16&&r!==17&&r!==18&&r!==91){n.preventDefault();c(r)}}else{var i=t.find("li.mfs-option.active"),s=!1;if(r===38){n.preventDefault();s=i.prevAll(".mfs-option:first");if(s.length>0){s.addClass("active");i.removeClass("active");h(t)}}else if(r===40){n.preventDefault();s=i.nextAll(".mfs-option:first");if(s.length>0){s.addClass("active");i.removeClass("active");h(t)}}else if(r===13)i.find("a").click();else if(r===27){e("ul.mfs-options").hide();t=!1}}})},refresh:function(){t=!1;i="";this.each(function(){var t=e(this).find("div.mfs-container");t.length>0&&t.each(function(){var t=e(this);l(t)})})},destroy:function(){t=!1;i="";this.each(function(){var t=e(this).find("div.mfs-container");t.length>0&&t.each(function(){var t=e(this);f(t)})})}};e.fn.mfs=function(t){if(p[t])return p[t].apply(this,Array.prototype.slice.call(arguments,1));if(typeof t=="object"||!t)return p.init.apply(this,arguments);e.error("Method "+t+" does not exist on jQuery.mfs")}})(jQuery);$.extend($.expr[":"],{mfscontains:function(e,t,n){return(e.textContent||e.innerText||"").toLowerCase().indexOf((n[3]||"").toLowerCase())>=0}});$.extend($.expr[":"],{mfssearch:function(e,t,n){var r=n[3].toLowerCase(),i=r.length;return(e.textContent||e.innerText||"").toLowerCase().substr(0,i)===r}});